#include "sys.h"
#include "delay.h"
#include "usart.h"
#include "led.h"
#include "usmart.h"
#include "ds18b20.h"
#include "pwm.h"
#include "timer.h"

#define Pr 200
#define Ir 1
#define Dr 0

#define Pl 400
#define Il 2
#define Dl 0

extern int totemp;
int huanjingwendu;
//ALIENTEK ̽STM32F407 ʵ14
//USMARTʵ -⺯汾
//֧֣www.openedv.com
//Ա̣http://eboard.taobao.com  
//ӿƼ޹˾  
//ߣԭ @ALIENTEK

int main(void)
{ 
	NVIC_PriorityGroupConfig(NVIC_PriorityGroup_2);//ϵͳжȼ2
	delay_init(168);      //ʼʱ
	uart_init(9600);		//ʼڲΪ115200
	usmart_dev.init(84); 	//ʼUSMART
	LED_Init();
	DS18B20_Init();
	TIM3_Int_Init(20000-1,8400-1);
	TIM_PWM_Init(20000-1,1680-1);	//1680
	TIM_SetCompare1(TIM13,0);	//
	TIM_SetCompare1(TIM14,0);//
	//TIM_SetCompare2(TIM12,40000);
	delay_ms(5000);
	//huanjingwendu=DS18B20_Get_Temp();
	huanjingwendu=260;
  	while(1) 
	{		 	  
		/*led_set(1);	 
		delay_ms(500);	
		led_set(0);		 
		delay_ms(500);	*/
	}
}
int pidforjiare(temp)
{
	static int lasttemp,sumtemp=0;
	int pidout;
	sumtemp+=temp;
	if(sumtemp>=4000)
		sumtemp=4000;
	if(sumtemp<=-4000)
		sumtemp=-4000;
	pidout=Pr*(temp)+Ir*sumtemp+Dr*(temp-lasttemp);
	lasttemp=temp;
	return pidout;
}
int pidforzhileng(temp)
{
	static int lasttemp,sumtemp=0;
	int pidout;
	sumtemp+=temp;
		if(sumtemp>=10000)
		sumtemp=10000;
	if(sumtemp<=-10000)
		sumtemp=-10000;
	pidout=Pl*(temp)+Il*sumtemp+Dl*(temp-lasttemp);
	lasttemp=temp;
	return pidout;
}
void TIM3_IRQHandler(void)
{
	int pidout;
	int temp=-1;
	if(TIM_GetITStatus(TIM3,TIM_IT_Update)==SET) //ж
	{
		while(temp<=0||temp>500)
		{temp=DS18B20_Get_Temp();}
			printf("temp=%d,huangjingwendu=%d\n",temp,huanjingwendu);
		if(totemp>huanjingwendu)
		{
     pidout=pidforjiare(temp-totemp);
		 if(pidout>0)
		 {
			TIM_SetCompare1(TIM13,0);
		 }
		 else
		 {
			TIM_SetCompare1(TIM13,-pidout);
		 }
	 }
	 if(totemp<huanjingwendu)
	 {
		 pidout=pidforzhileng(temp-totemp);
		 if(pidout>0)
		 {
			 TIM_SetCompare1(TIM14,pidout);
		 }
		 else
		 {
			TIM_SetCompare1(TIM14,0);  
		 }
	 }
	} 
	TIM_ClearITPendingBit(TIM3,TIM_IT_Update);  //жϱ־λ
}
